#!/bin/sh
# Create a .wbt file for the current version of this theme, save it in the
# the virtualmin directory, and update the updates.txt file.

if [ "$1" = "--noupdate" ]; then
	noupdate=1
	shift
fi
if [ "$2" != "" ]; then
	echo "usage: createvirtualmintheme.sh [--noupdate] [version]"
	exit 1
fi

# Work out the version
cd /usr/local/webadmin
if [ "$1" != "" ]; then
	version=$1
else
	version=`grep version= virtual-server-theme/theme.info | sed -e 's/version=//'`
fi

# Create .wbm.gz and .rpm files
./create-module.pl virtualmin/virtual-server-theme-$version.wbt.gz virtual-server-theme/$version
./makemodulerpm.pl --target-dir virtualmin/rpm virtual-server-theme $version

if [ "$noupdate" = "" ]; then
	# Add to updates.txt for .wbt
	grep virtual-server-theme-$version.wbt.gz virtualmin/updates.txt >/dev/null
	if [ "$?" != 0 ]; then
		echo "virtual-server-theme	$version	virtual-server-theme-$version.wbt.gz	0	Latest version of Virtualmin Theme" >/tmp/updates.txt.$$
		cat virtualmin/updates.txt >>/tmp/updates.txt.$$
		mv /tmp/updates.txt.$$ virtualmin/updates.txt
	fi

	# Add to updates.txt for .rpm
	grep wbt-virtual-server-theme-$version-1.noarch.rpm virtualmin/rpm/updates.txt >/dev/null
	if [ "$?" != 0 ]; then
		echo "virtual-server-theme	$version	wbt-virtual-server-theme-$version-1.noarch.rpm	0	Latest version of Virtualmin Theme" >/tmp/updates.txt.$$
		cat virtualmin/rpm/updates.txt >>/tmp/updates.txt.$$
		mv /tmp/updates.txt.$$ virtualmin/rpm/updates.txt
	fi
fi

